// Generated by dts-bundle v0.7.3

declare module 'ts-json-schema-decorator' {
    export * from 'ts-json-schema-decorator/model';
    export * from 'ts-json-schema-decorator/property';
    export * from 'ts-json-schema-decorator/utils';
}

declare module 'ts-json-schema-decorator/model' {
    export function Definitions(...defs: any[]): (model: any) => void;
    export function Model(options?: {}): any;
}

declare module 'ts-json-schema-decorator/property' {
    /**
        * Validate that this value is specified
        * @param {boolean} required Validation fails if unspecified (null/undefined)
        */
    export function Required(required?: boolean): (model: any, key: any) => void;
    /**
        * TODO
        * @param dependency
        */
    export function Dependency(dependency: any): (model: any, key: any) => void;
    /**
        * Declare this a property and give custom options
        * TODO: option list fron js-data json schema
        * @param {hash} opts List of options to give
        */
    export function Property(opts?: {}): (model: any, key: any) => void;
    /**
        * TODO
        * @param definition
        */
    export function Defined(definition: any): (model: any, key: any) => void;
    /**
        * Declare the unitary type of a property
        * @param {function} type Constructor
        */
    export function Type(type: any): (model: any, key: any) => void;
    /**
        * Gives the value to give to the property if it is not specified
        * @param {any} value Value given to the property if not specified
        */
    export function Default(value: any): (model: any, key: any) => void;
    /**
        * List the possible values of this property
        * @param {array(any)} values List of accepted valued
        */
    export function Enum(...values: any[]): (model: any, key: any) => void;
    /**
        * TODO
        * @param format
        */
    export function Format(format: any): (model: any, key: any) => void;
    /**
        * TODO
        * @param additionalProperties
        */
    export function AdditionalProperties(additionalProperties: boolean | object): (model: any, key: any) => void;
    /**
        * TODO
        * @param patternProperties
        */
    export function PatternProperties(patternProperties: object): (model: any, key: any) => void;
    /**
        * Specifies the validation pattern of the string
        * @param {regexp} pattern Validation reg-exp
        */
    export function Pattern(pattern: any): (model: any, key: any) => void;
    /**
        * Gives a minimum length of the string
        * @param {number} minLength The minimum number of characters in the string
        */
    export function MinLength(minLength?: number): (model: any, key: any) => void;
    /**
        * Gives a maximum length of the string
        * @param {number} maxLength The maximum number of characters in the string
        */
    export function MaxLength(maxLength: any): (model: any, key: any) => void;
    /**
        * Specify there is no fractional part to this number
        */
    export const Integer: (model: any, key: any) => void;
    /**
        * Gives a minimum value of a number
        * @param {number} minimum The minimum value of the property
        */
    export function Minimum(minimum?: number, exclusiveMinimum?: boolean): (model: any, key: any) => void;
    /**
        * Gives a maximum value of a number
        * @param {number} maximum The maximum value of the property
        */
    export function Maximum(maximum: any, exclusiveMaximum?: boolean): (model: any, key: any) => void;
    /**
        * Explicit the possible type(s) of the array items
        * @param {array(function)} items List of constructors of accepted types
        * @param uniqueItems TODO
        * @example @Items([Number, 'boolean', Address, {$ref: 'name'}])
        * @example @Items(String)
        */
    export function Items(items: any, uniqueItems?: boolean): (model: any, key: any) => void;
    /**
        * Gives a minimum number of items for an array
        * @param {number} minItems The minimum number of items to validate an array
        */
    export function MinItems(minItems: any): (model: any, key: any) => void;
    /**
        * Gives a maximum number of items for an array
        * @param {number} maxItems The maximum number of items to validate an array
        */
    export function MaxItems(maxItems: any): (model: any, key: any) => void;
}

declare module 'ts-json-schema-decorator/utils' {
    import 'reflect-metadata';
    export const factories: {
        makeType: any[];
    };
    export const jsdTypes: {
        Array: string;
        String: string;
        Number: string;
        Boolean: string;
        Object: string;
    };
    export function option(value: any, model: any, ...path: any[]): any;
    export function getPropertyDescriptor(model: any, key: any): any;
    export function createPropertyDecorator(descriptor: any, restriction?: any): (model: any, key: any) => void;
    export function makeType(type: any, model: any, property: any): any;
}

